import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, Input, Output, Pipe, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgPaginationComponentService {
    constructor() { }
}
NgPaginationComponentService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgPaginationComponentService.ctorParameters = () => [];
/** @nocollapse */ NgPaginationComponentService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgPaginationComponentService_Factory() { return new NgPaginationComponentService(); }, token: NgPaginationComponentService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgPaginationComponentComponent {
    constructor() {
        this.paginationList = [];
        this.itemsPerPage = 1;
        this.currentPage = 1;
        this.countInfo = false;
        this.newCurrentPage = new EventEmitter();
        this.pageNumbersLength = new EventEmitter();
        this.pageNumbers = [];
        this.slicedPageNumbers = [];
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (this.getClickedNumber === undefined) {
            this.getClickedNumber = this.currentPage;
        }
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        this.pageNumbers = [];
        if (this.paginationList.length > 0 && this.itemsPerPage !== null && this.itemsPerPage > 0) {
            for (let i = 1; i <= Math.ceil(this.paginationList.length / this.itemsPerPage); i++) {
                this.pageNumbers.push(i);
            }
        }
        this.pageNumbersLength.emit(this.pageNumbers.length);
        this.getClickedNumber = this.currentPage;
    }
    /**
     * @param {?} pageNumber
     * @return {?}
     */
    getPageNumber(pageNumber) {
        this.newCurrentPage.emit(pageNumber);
        this.getClickedNumber = pageNumber;
        this.countShowingItems(pageNumber);
    }
    /**
     * @return {?}
     */
    goPrevPage() {
        this.newCurrentPage.emit(this.getClickedNumber - 1);
        this.countShowingItems(this.getClickedNumber - 1);
        this.getClickedNumber--;
    }
    /**
     * @return {?}
     */
    goNextPage() {
        this.newCurrentPage.emit(this.getClickedNumber + 1);
        this.countShowingItems(this.getClickedNumber + 1);
        this.getClickedNumber++;
    }
    /**
     * @param {?} pageNumber
     * @return {?}
     */
    countShowingItems(pageNumber) {
        /** @type {?} */
        const indexOfLastTodo = pageNumber * this.itemsPerPage;
        /** @type {?} */
        const indexOfFirstTodo = indexOfLastTodo - this.itemsPerPage;
        this.slicedPageNumbers = [...this.paginationList.slice(indexOfFirstTodo, indexOfLastTodo)];
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
    }
}
NgPaginationComponentComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-ng-pagination-component',
                template: "<div *ngIf=\"countInfo === true\" class=\"count-info\">\r\n    <ng-template [ngIf]=\"currentPage === 1 && paginationList.length >= itemsPerPage\">\r\n        <p>Showing {{currentPage}} to {{itemsPerPage}}\r\n            of {{paginationList.length}} items</p>\r\n    </ng-template>\r\n    <ng-template [ngIf]=\"currentPage === 1 && paginationList.length < itemsPerPage\">\r\n        <p>Showing {{currentPage}} to {{paginationList.length}}\r\n            of {{paginationList.length}} items</p>\r\n    </ng-template>\r\n    <ng-template [ngIf]=\"currentPage !== 1 && currentPage * itemsPerPage <= paginationList.length\">\r\n        <p>Showing {{(itemsPerPage * currentPage) - (itemsPerPage - 1)}} to\r\n            {{currentPage * itemsPerPage}} of {{paginationList.length}} items</p>\r\n    </ng-template>\r\n    <ng-template [ngIf]=\"currentPage !== 1 && currentPage * itemsPerPage > paginationList.length\">\r\n        <p>Showing {{(paginationList.length - slicedPageNumbers.length) + 1}} to\r\n            {{paginationList.length}} of {{paginationList.length}} items</p>\r\n  </ng-template>\r\n</div>\r\n<ul id=\"page-numbers\" *ngIf=\"paginationList.length > itemsPerPage\">\r\n  <ng-template [ngIf]=\"pageNumbers.length > 6\">\r\n    <li>\r\n      <button class=\"prev-next\" (click)=\"goPrevPage()\" [disabled]=\"getClickedNumber === 1\">\r\n        <\r\n      </button>\r\n    </li>\r\n    <li *ngFor=\"let number of pageNumbers; let i = index\" style=\"display: flex\">\r\n      <p *ngIf=\"number === 1\" [ngClass]=\"currentPage === number ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(number)\">{{number}}</p>\r\n      <ng-template [ngIf]=\"getClickedNumber < 5 && i === 0\">\r\n        <p [ngClass]=\"currentPage === number + 1 ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(number + 1)\">{{number + 1}}</p>\r\n        <p [ngClass]=\"currentPage === number + 2 ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(number + 2)\">{{number + 2}}</p>\r\n        <p [ngClass]=\"currentPage === number + 3 ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(number + 3)\">{{number + 3}}</p>\r\n        <p [ngClass]=\"currentPage === number + 4 ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(number + 4)\">{{number + 4}}</p>\r\n        <p class=\"not-current-pages\" (click)=\"getPageNumber(pageNumbers.length - 1)\">. . .</p>\r\n      </ng-template>\r\n      <ng-template [ngIf]=\"getClickedNumber >= 5 && getClickedNumber <= pageNumbers.length - 3 && i === 0\">\r\n        <p class=\"not-current-pages\" (click)=\"getPageNumber(2)\">. . .</p>\r\n        <p [ngClass]=\"currentPage === getClickedNumber - 1 ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(getClickedNumber - 1)\">{{getClickedNumber - 1}}</p>\r\n        <p [ngClass]=\"currentPage === getClickedNumber ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(getClickedNumber)\">{{getClickedNumber}}</p>\r\n        <p [ngClass]=\"currentPage === getClickedNumber + 1? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(getClickedNumber + 1)\">{{getClickedNumber + 1}}</p>\r\n        <p class=\"not-current-pages\" (click)=\"getPageNumber(pageNumbers.length - 1)\">. . .</p>\r\n      </ng-template>\r\n      <ng-template [ngIf]=\"getClickedNumber >= 5 && getClickedNumber > pageNumbers.length - 3 && i === 0\">\r\n        <p class=\"not-current-pages\" (click)=\"getPageNumber(2)\">. . .</p>\r\n        <p [ngClass]=\"currentPage === pageNumbers.length - 4 ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(pageNumbers.length - 4)\">{{pageNumbers.length - 4}}</p>\r\n        <p [ngClass]=\"currentPage === pageNumbers.length - 3 ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(pageNumbers.length - 3)\">{{pageNumbers.length - 3}}</p>\r\n        <p [ngClass]=\"currentPage === pageNumbers.length - 2 ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(pageNumbers.length - 2)\">{{pageNumbers.length - 2}}</p>\r\n        <p [ngClass]=\"currentPage === pageNumbers.length - 1 ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(pageNumbers.length - 1)\">{{pageNumbers.length - 1}}</p>\r\n      </ng-template>\r\n      <p *ngIf=\"number === pageNumbers.length\" [ngClass]=\"currentPage === number ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(number)\">{{number}}</p>\r\n    </li>\r\n    <li>\r\n      <button class=\"prev-next\" (click)=\"goNextPage()\" [disabled]=\"getClickedNumber === pageNumbers.length\"> > </button>\r\n    </li>\r\n  </ng-template>\r\n  <ng-template [ngIf]=\"pageNumbers.length <= 6\">\r\n    <li>\r\n      <button class=\"prev-next\" (click)=\"goPrevPage()\" [disabled]=\"getClickedNumber === 1\">\r\n        <\r\n      </button>\r\n    </li>\r\n    <li *ngFor=\"let number of pageNumbers; let i = index\" style=\"display: flex\">\r\n      <p [ngClass]=\"currentPage === number ? 'current-page' : 'not-current-pages'\" (click)=\"getPageNumber(number)\">{{number}}</p>\r\n    </li>\r\n    <li>\r\n      <button class=\"prev-next\" (click)=\"goNextPage()\" [disabled]=\"getClickedNumber === pageNumbers.length\"> > </button>\r\n    </li>\r\n  </ng-template>\r\n</ul>\r\n",
                styles: [".count-info{font-size:14px}#page-numbers{list-style-type:none;display:flex;align-items:center;padding-left:0;justify-content:center;padding-bottom:1rem;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;font-size:17px;flex-wrap:wrap}#page-numbers .current-page{margin-right:10px;background:#716aca;border-radius:50%;text-align:center;line-height:38px;height:40px;width:40px;color:#fff}#page-numbers .current-page:hover{cursor:pointer}#page-numbers .not-current-pages{margin-right:10px;background:#ebe9f2;border-radius:50%;text-align:center;line-height:38px;height:40px;width:40px;color:#000;transition:background-color .1s,opacity .1s}#page-numbers .not-current-pages:hover{cursor:pointer;background-color:#716aca;color:#fff;opacity:.8}#page-numbers .prev-next{margin-right:10px;background:#ebe9f2;border-radius:50%;text-align:center;line-height:38px;height:40px;width:40px;color:#000;border:none;transition:.1s}#page-numbers .prev-next:hover{cursor:pointer;background-color:#716aca;opacity:.8;color:#fff}"]
            }] }
];
/** @nocollapse */
NgPaginationComponentComponent.ctorParameters = () => [];
NgPaginationComponentComponent.propDecorators = {
    paginationList: [{ type: Input }],
    itemsPerPage: [{ type: Input }],
    currentPage: [{ type: Input }],
    countInfo: [{ type: Input }],
    newCurrentPage: [{ type: Output }],
    pageNumbersLength: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    NgPaginationComponentComponent.prototype.paginationList;
    /** @type {?} */
    NgPaginationComponentComponent.prototype.itemsPerPage;
    /** @type {?} */
    NgPaginationComponentComponent.prototype.currentPage;
    /** @type {?} */
    NgPaginationComponentComponent.prototype.countInfo;
    /** @type {?} */
    NgPaginationComponentComponent.prototype.newCurrentPage;
    /** @type {?} */
    NgPaginationComponentComponent.prototype.pageNumbersLength;
    /** @type {?} */
    NgPaginationComponentComponent.prototype.pageNumbers;
    /** @type {?} */
    NgPaginationComponentComponent.prototype.getClickedNumber;
    /** @type {?} */
    NgPaginationComponentComponent.prototype.slicedPageNumbers;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PaginationPipe {
    /**
     * @param {?} value
     * @param {?} arg1
     * @return {?}
     */
    transform(value, arg1) {
        /** @type {?} */
        const indexOfLastTodo = arg1.currentPage * arg1.itemsPerPage;
        /** @type {?} */
        const indexOfFirstTodo = indexOfLastTodo - arg1.itemsPerPage;
        return value.slice(indexOfFirstTodo, indexOfLastTodo);
    }
}
PaginationPipe.decorators = [
    { type: Pipe, args: [{
                name: 'paginate',
                pure: false
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgPaginationComponentModule {
}
NgPaginationComponentModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgPaginationComponentComponent, PaginationPipe],
                imports: [CommonModule, FormsModule, ReactiveFormsModule
                ],
                exports: [NgPaginationComponentComponent, PaginationPipe]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgPaginationComponentComponent, NgPaginationComponentModule, NgPaginationComponentService, PaginationPipe as ɵa };
//# sourceMappingURL=ng-pagination-component.js.map
